(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('lodash'), require('react-dom'), require('miwencc')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'lodash', 'react-dom', 'miwencc'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.switch = {}, global.React, global._, global.ReactDOM));
}(this, (function (exports, React, _, ReactDOM) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
  var ___default = /*#__PURE__*/_interopDefaultLegacy(_);
  var ReactDOM__default = /*#__PURE__*/_interopDefaultLegacy(ReactDOM);

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived),
          result;

      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;

        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }

      return _possibleConstructorReturn(this, result);
    };
  }

  window.__miwencc__.register("component_case_1", {
    "name": "component_case_1",
    "url": "http://localhost:10000/component_case_1/index.html",
    "containerStyle": {
      "border": "1px solid red",
      "width": "500px",
      "height": "500px",
      "overflow": "hidden"
    },
    "autoReady": true,
    "options": [{
      "name": "command"
    }],
    "properties": [{
      "name": "op",
      "type": "set"
    }, {
      "name": "count",
      "type": "get"
    }],
    "events": [],
    "methods": [],
    "version": "0.1.3",
    "author": "miwen"
  });

  var ComponentCase1 = /*#__PURE__*/function (_React$Component) {
    _inherits(ComponentCase1, _React$Component);

    var _super = _createSuper(ComponentCase1);

    function ComponentCase1(props) {
      var _this;

      _classCallCheck(this, ComponentCase1);

      _this = _super.call(this, props);
      _this.instance = null;
      _this.state = {};
      return _this;
    }

    _createClass(ComponentCase1, [{
      key: "op",
      set: function set(value) {
        return window.__miwencc__.setProperty(this.instance.instanceId, 'op', value);
      }
    }, {
      key: "count",
      get: function get() {
        return window.__miwencc__.getProperty(this.instance.instanceId, 'count', this.props.count);
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps, prevState) {
        if (!___default['default'].isEqual(this.props.options, prevProps.options)) {
          window.__miwencc__.setProperty(this.instance.instanceId, 'options', this.props.options).then(function (result) {});
        }
      }
    }, {
      key: "componentDidMount",
      value: function componentDidMount() {
        this.instance = window.__miwencc__.createInstance("component_case_1", ReactDOM__default['default'].findDOMNode(this.refs.container));

        if (this.props.options) {
          window.__miwencc__.setProperty(this.instance.instanceId, 'options', this.props.options).then(function (result) {});
        }
      }
    }, {
      key: "render",
      value: function render() {
        return /*#__PURE__*/React__default['default'].createElement("div", {
          ref: "container"
        });
      }
    }]);

    return ComponentCase1;
  }(React__default['default'].Component);

  exports.ComponentCase1 = ComponentCase1;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
